﻿using Borepin.Base;
using Prism.Navigation;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace Borepin.PageModel
{
    public class MainPagePageModel : PageModelBase
    {
        #region Constructors
        public MainPagePageModel(INavigationService navigationService) : base(navigationService)
        {
            NavigateCommand = new Command<string>(NavigateCommandExecuted);
        }
        #endregion

        #region LoadData
        public override async Task LoadData()
        {
            IsBusy = true;

            IsBusy = false;
            await LoadData();
        }
        #endregion

        #region Commands
        private ICommand _NavigationCommand;

        public ICommand NavigateCommand 
        {
            get => _NavigationCommand;
            set => SetProperty(ref _NavigationCommand, value);
        }

        private async void NavigateCommandExecuted(string view)
        {
            var result = await _NavigationService.NavigateAsync($"NavigationPage/{view}");
            if(!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }
        #endregion

        #region INavigationService
        public override void OnNavigatedFrom(INavigationParameters parameters)
        {

        }

        public override void OnNavigatedTo(INavigationParameters parameters)
        {
            IsBusy = true;
            Task.Run(LoadData);
        }
        #endregion
    }
}
