﻿using System.Threading.Tasks;
using Borepin.Model;

namespace Borepin.Service.Credentials
{
    public interface ICredentialService
    {
        /// <summary>
        /// Get Password for Connection from SecureStorage
        /// </summary>
        /// <param name="connection">address + username</param>
        Task<string> GetPasswordAsync(Connection connection);

        /// <summary>
        /// Add Credentials to SecureStorage
        /// </summary>
        /// <param name="connection">address + username</param>
        Task<bool> AddCredentialsAsync(Connection connection, string password);

        /// <summary>
        /// Remove Credentials from SecureStorage
        /// </summary>
        /// <param name="connection"><address + username/param>
        Task<bool> RemoveCredentialsAsync(Connection connection);
    }
}
